"use strict";

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = exports.count = exports.add = exports.create = exports.remove = exports.get = undefined;

var _extends = _assign2.default || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var get = exports.get = function () {
  var _ref2 = _asyncToGenerator(_regenerator2.default.mark(function _callee(instance, label, relationType, props, relationProps) {
    var _this = this;

    var _prepareWhere, where, flatProps, relationString, result;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _prepareWhere = (0, _utils.prepareWhere)({ b: props, r: relationProps }, ["b", "r"]), where = _prepareWhere.where, flatProps = _prepareWhere.flatProps;
            relationString = getRelationString(label, relationType);
            _context.next = 4;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{_srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    " + where + "\n    RETURN b, r\n  ", _extends({ _srcGuid: instance.props.guid }, flatProps));

          case 4:
            result = _context.sent;
            return _context.abrupt("return", _promise2.default.resolve(result.map(function (p) {
              var instance = _this.dest._createModelInstance(p.b);
              instance.relationProps = p.r;
              return instance;
            })));

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function get(_x, _x2, _x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var remove = exports.remove = function () {
  var _ref3 = _asyncToGenerator(_regenerator2.default.mark(function _callee2(instance, label, relationType, props, relationProps) {
    var _prepareWhere2, where, flatProps, relationString, result;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _prepareWhere2 = (0, _utils.prepareWhere)({ b: props, r: relationProps }, ["b", "r"]), where = _prepareWhere2.where, flatProps = _prepareWhere2.flatProps;
            relationString = getRelationString(label, relationType);
            _context2.next = 4;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{_srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    " + where + "\n    DELETE r\n    ", _extends({ _srcGuid: instance.props.guid }, flatProps));

          case 4:
            result = _context2.sent;
            return _context2.abrupt("return", _promise2.default.resolve(result._stats));

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function remove(_x6, _x7, _x8, _x9, _x10) {
    return _ref3.apply(this, arguments);
  };
}();

var create = exports.create = function () {
  var _ref4 = _asyncToGenerator(_regenerator2.default.mark(function _callee3(instance, label, relationType, propsArray, relationProps) {
    var destInstances, relationString, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, props, destInstance;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            destInstances = [];
            relationString = getRelationString(label, relationType, relationProps);
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context3.prev = 5;
            _iterator = (0, _getIterator3.default)(propsArray);

          case 7:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context3.next = 18;
              break;
            }

            props = _step.value;
            _context3.next = 11;
            return this.dest.create(props);

          case 11:
            destInstance = _context3.sent;

            destInstances.push(destInstance);
            _context3.next = 15;
            return _index2.default.run("\n      MATCH\n        (a:" + this.src.label + " {guid:{srcGuid}}),\n        (b:" + this.dest.label + " {guid:{destGuid}})\n      MERGE (a)" + relationString + "(b)\n    ", {
              srcGuid: instance.props.guid,
              destGuid: destInstance.props.guid,
              relationProps: relationProps
            });

          case 15:
            _iteratorNormalCompletion = true;
            _context3.next = 7;
            break;

          case 18:
            _context3.next = 24;
            break;

          case 20:
            _context3.prev = 20;
            _context3.t0 = _context3["catch"](5);
            _didIteratorError = true;
            _iteratorError = _context3.t0;

          case 24:
            _context3.prev = 24;
            _context3.prev = 25;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 27:
            _context3.prev = 27;

            if (!_didIteratorError) {
              _context3.next = 30;
              break;
            }

            throw _iteratorError;

          case 30:
            return _context3.finish(27);

          case 31:
            return _context3.finish(24);

          case 32:
            return _context3.abrupt("return", _promise2.default.resolve(destInstances));

          case 33:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this, [[5, 20, 24, 32], [25,, 27, 31]]);
  }));

  return function create(_x11, _x12, _x13, _x14, _x15) {
    return _ref4.apply(this, arguments);
  };
}();

var add = exports.add = function () {
  var _ref5 = _asyncToGenerator(_regenerator2.default.mark(function _callee4(instance, label, relationType, instances, relationProps) {
    var relationString, relationshipsCreated, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, destInstance, result;

    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            relationString = getRelationString(label, relationType, relationProps);
            relationshipsCreated = 0;
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context4.prev = 5;
            _iterator2 = (0, _getIterator3.default)(instances);

          case 7:
            if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
              _context4.next = 16;
              break;
            }

            destInstance = _step2.value;
            _context4.next = 11;
            return _index2.default.run("\n      MATCH\n        (a:" + this.src.label + " {guid:{srcGuid}}),\n        (b:" + this.dest.label + " {guid:{destGuid}})\n      MERGE (a)" + relationString + "(b)\n    ", {
              srcGuid: instance.props.guid,
              destGuid: destInstance.props.guid,
              relationProps: relationProps
            });

          case 11:
            result = _context4.sent;


            relationshipsCreated += result._stats.relationshipsCreated;

          case 13:
            _iteratorNormalCompletion2 = true;
            _context4.next = 7;
            break;

          case 16:
            _context4.next = 22;
            break;

          case 18:
            _context4.prev = 18;
            _context4.t0 = _context4["catch"](5);
            _didIteratorError2 = true;
            _iteratorError2 = _context4.t0;

          case 22:
            _context4.prev = 22;
            _context4.prev = 23;

            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }

          case 25:
            _context4.prev = 25;

            if (!_didIteratorError2) {
              _context4.next = 28;
              break;
            }

            throw _iteratorError2;

          case 28:
            return _context4.finish(25);

          case 29:
            return _context4.finish(22);

          case 30:
            return _context4.abrupt("return", _promise2.default.resolve(relationshipsCreated));

          case 31:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this, [[5, 18, 22, 30], [23,, 25, 29]]);
  }));

  return function add(_x16, _x17, _x18, _x19, _x20) {
    return _ref5.apply(this, arguments);
  };
}();

var count = exports.count = function () {
  var _ref6 = _asyncToGenerator(_regenerator2.default.mark(function _callee5(instance, label, relationType, props, relationProps) {
    var _ref;

    var _prepareWhere3, where, flatProps, relationString, result, low;

    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _prepareWhere3 = (0, _utils.prepareWhere)({ b: props, r: relationProps }, ["b", "r"]), where = _prepareWhere3.where, flatProps = _prepareWhere3.flatProps;
            relationString = getRelationString(label, relationType);
            _context5.next = 4;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{_srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    " + where + "\n    RETURN COUNT(b) as b\n  ", _extends({ _srcGuid: instance.props.guid }, flatProps));

          case 4:
            result = _context5.sent;


            // $FlowFixMe
            low = ((_ref = result) != null ? (_ref = _ref._raw) != null ? (_ref = _ref.records) != null ? (_ref = _ref[0]) != null ? (_ref = _ref._fields) != null ? (_ref = _ref[0]) != null ? _ref.low : _ref : _ref : _ref : _ref : _ref : _ref) || -1;
            return _context5.abrupt("return", _promise2.default.resolve(low));

          case 7:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function count(_x21, _x22, _x23, _x24, _x25) {
    return _ref6.apply(this, arguments);
  };
}();

var update = exports.update = function () {
  var _ref7 = _asyncToGenerator(_regenerator2.default.mark(function _callee6(instance, label, relationType, props, whereProps, relationProps, whereRelationProps) {
    var _this2 = this;

    var _prepareWhere4, where, flatProps, _prepareSet, setPropsStr, newProps, relationString, result;

    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _prepareWhere4 = (0, _utils.prepareWhere)({ b: whereProps, r: whereRelationProps }, ["b", "r"]), where = _prepareWhere4.where, flatProps = _prepareWhere4.flatProps;
            _prepareSet = (0, _utils.prepareSet)({
              b: props,
              r: relationProps
            }, ["b", "r"]), setPropsStr = _prepareSet.str, newProps = _prepareSet.newProps;
            relationString = getRelationString(label, relationType);
            _context6.next = 5;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{_srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    " + where + "\n    SET " + setPropsStr + "\n    RETURN b\n  ", _extends({ _srcGuid: instance.props.guid }, flatProps, newProps));

          case 5:
            result = _context6.sent;
            return _context6.abrupt("return", _promise2.default.resolve(result.map(function (a) {
              return _this2.dest._createModelInstance(a.b);
            })));

          case 7:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function update(_x26, _x27, _x28, _x29, _x30, _x31, _x32) {
    return _ref7.apply(this, arguments);
  };
}();

var _index = require("./index");

var _index2 = _interopRequireDefault(_index);

var _utils = require("./utils");

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _promise2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _promise2.default.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var relationPropsKey = "relationProps";

function getRelationString(label, relationType, relationProps) {
  var relationPropsStr = "";
  if (relationProps) {
    relationPropsStr = (0, _lodash.keys)(relationProps).map(function (key) {
      return key + ": {" + relationPropsKey + "}." + key;
    }).join(", ");
  }

  if (relationType.any) {
    return "-[r:" + label + " {" + relationPropsStr + "}]-";
  }
  return (!relationType.out && !relationType.any ? "<" : "") + "-[r:" + label + " {" + relationPropsStr + "}]-" + (!relationType.out && !relationType.any ? "" : ">");
}