"use strict";

var _defineProperty = require("babel-runtime/core-js/object/define-property");

var _defineProperty2 = _interopRequireDefault(_defineProperty);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectHelper = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; (0, _defineProperty2.default)(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _Model = require("../Model");

var _ModelInstance = require("../ModelInstance");

var _Relation = require("../Relation");

var _index = require("./index");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ConnectHelper = function () {
  function ConnectHelper() {
    _classCallCheck(this, ConnectHelper);

    this.models = [];
  }

  _createClass(ConnectHelper, [{
    key: "tryInject",
    value: function tryInject() {
      var buf = [];

      this.models.forEach(function (m) {
        var model = (0, _index.lazy)(m.model);
        if (model) {
          model.modelInstanceClass = m.modelInstance;
          if (m.relations) {
            model.relations = m.relations.map(function (r) {
              return new _Relation.Relation(model, r);
            });
          }
        } else {
          buf.push(m);
        }
      });

      this.models = buf;
    }
  }]);

  return ConnectHelper;
}();

var connectHelper = exports.connectHelper = new ConnectHelper();